import sys
import random
port = random.randint(1024, 65535) #hack because I have no idea about this
sys.argv.append(str(port))

import os.path
import cPickle
import json

import web


import project



render = web.template.render('templates', base = 'base')
web.template.Template.globals.update({'map':map,
                                      'str':str,
                                      'enumerate':enumerate,
                                      'getattr':getattr,
                                      'zip':zip,
                                      'round':round,
                                      'hasattr':hasattr})





                                      


p = cPickle.load(open('project.bility'))




urls = (
        '/edit/vulnerability/nameweights/(\d+)','EditNameWeights',
        '/edit/indicator/(\d+)/([\w\s]+)/(\d+)','EditIndicator',
        '/edit/vulnerability/(\d+)','EditVulnerability',

        '/view/vulnerability/(\d+)', 'ViewVulnerability',

        '/view/vulnerabilities','ViewVulnerabilities',
        '/new/vulnerability','NewVulnerability',
        '/new/indicator/(\d+)/([\w\s]+)','NewIndicator',

        '/new/datasource', 'NewDataSource',
        '/view/datasources', 'ViewDataSources',
        '/edit/datasource/(\d+)', 'EditDataSource',

        '/view/pairings', 'ViewPairings',
        '/new/pairing', 'NewPairing',
        '/edit/pairing/(\d+)/(\d+)', 'EditPairing',




        '/rsc/(\S+)', 'Static',
        '/', 'Home',

        '/view/tables', 'ViewTables',


        '/view/table/(\d+)/(\d*)', 'ViewResultsTable',

        '/view/maps', 'ViewMaps',
        '/view/map/(\d+)/(\d+)', 'ViewMap',

        '/view/calculationdetail/(\d+)/(\d+)/(\d+)', 'ViewCalculationDetail',

        
        )



class ViewCalculationDetail:
    def GET(self,dsid, assetid, vid):
        dsid = int(dsid)
        assetid = int(assetid)
        vid = int(vid)

        

        asset = p.getAssets(dsid)[1][assetid]

        vulnerability = p.vulnerabilities[vid]
        datasource = p.datasources[dsid]


        score = p.getResults(dsid, vid)[assetid]

        return render.detail(asset, vulnerability, score, datasource)

        




class ViewVulnerability:
    def GET(self, vid):
        vid = int(vid)
        vulnerability = p.vulnerabilities[vid]
        return render.method(vid, vulnerability)
        



class ViewMap:
    def GET(self, dsid, vid):
        dsid = int(dsid)
        vid = int(vid)

        crs, assets = p.getAssets(dsid)

        scores, vids = p.tabulate(dsid, vid, [vid])

        scores = scores[:20]

        features = []

        for asset_id, s in scores:
            feature = project.get_feature(assets[asset_id], asset_id)

            feature['properties'].update({'score': s[vid].overall})

            features.append(feature)

        collection = {'type': 'FeatureCollection',
                      'features': features}

        
        #return collection
        return render.view_map(json.dumps(collection), dsid, vid, p)

        


class ViewMaps:
    def GET(self):
        return render.view_maps(p)

class ViewTables:
    def GET(self):
        return render.view_tables(p.datasources)


class Home:
    def GET(self):
        return render.home()


class Static:
    def GET(self, fname):
        f = open(resource_path('rsc/'+fname)).read()
        return f
        



class ViewResultsTable:
    def GET(self, dsid, vid = None):
        dsid = int(dsid)
        
        

        if vid != "":
            vid = int(vid)
        else:
            vid = None


        scores, vids = p.tabulate(dsid, vid)



        return render.view_table(p, scores, dsid, vid, vids)

        


class ViewPairings:
    def GET(self):
        return render.view_pairings(p.results, p.datasources, p.vulnerabilities)

class NewPairing:
    def POST(self):
        dsid, vid = min(p.datasources), min(p.vulnerabilities)
        
        p.newCalculation(dsid, vid)
        web.seeother('/edit/pairing/{}/{}'.format(dsid, vid))


class EditPairing:
    def GET(self, dsid, vid):
        dsid = int(dsid)
        vid = int(vid)

        return render.edit_pairing(dsid, vid, p.datasources, p.vulnerabilities,
                                       p.datasources[dsid], p.vulnerabilities[vid])
        
    def POST(self, dsid, vid):
        old_did = int(dsid)
        old_vid = int(vid)

        data = web.input()

        new_did = int(data['datasource'])
        new_vid = int(data['vulnerability'])

        p.updateCalculation(old_did, old_vid, new_did, new_vid)

        web.seeother('/view/pairings')


class ViewVulnerabilities:
    def GET(self):
        return render.view_vulnerabilities(p.vulnerabilities)

class ViewDataSources:
    def GET(self):
        return render.view_datasources(p.datasources)

class NewDataSource:
    def POST(self):
        ID = p.newDataSource()
        web.seeother('/edit/datasource/{}'.format(ID))
        

class EditDataSource:
    def GET(self, ID):
        ID = int(ID)
        datasource = p.datasources[ID]
        return render.edit_datasource(datasource)

    def POST(self, dsid):
        dsid = int(dsid)
        data = web.input()

        p.updateDataSource(dsid,
            data['name'], data['path'], data['id_field'], data['name_field'])
        web.seeother('/view/datasources')


class NewVulnerability:
    def POST(self):
        ID = p.newVulnerability()
        web.seeother('/view/vulnerability/{}'.format(ID))
        

class EditVulnerability:
    def GET(self, vid):
        vid = int(vid)
        return render.view_vulnerability(vid, p.vulnerabilities[vid])

    def POST(self, vid):
        web.seeother('/view/vulnerabilities')
        
class NewIndicator:
    def POST(self, vid, component):
        vid = int(vid)
        ID = p.newIndicator(vid, component)
        web.seeother('/edit/indicator/{}/{}/{}'.format(vid, component, ID))
        


        
        
class EditNameWeights:
    def GET(self, vid):
        vid = int(vid)
        return render.edit_vulnerability(p.vulnerabilities[vid])

    def POST(self, vid):
        vid = int(vid)
        data = web.input()


        weights = {
            'exposure': float(data['exposure weight']),
            'sensitivity': float(data['sensitivity weight']),
            'adaptive capacity': float(data['adaptive capacity weight'])
            }

        p.updateVulnerability(vid, data['name'], weights)

        
        web.seeother('/edit/vulnerability/{}'.format(vid))
 

class EditIndicator:

    def GET(self, vid, component, iid):

        vid = int(vid)
        iid = int(iid)
        print p.vulnerabilities
        weight, indicator, normalizer = \
                   p.vulnerabilities[vid].indicators[component][iid]


        normalizer_type = p._get_normalizer_type(normalizer)
        dtype = p.dtypes[(vid, component, iid)]



        return render.edit_indicator(indicator, normalizer, weight,
                                    vid, component, iid, 
                                    normalizer_type, dtype)

    def POST(self, vid, component, iid):
        vid = int(vid)
        iid = int(iid)
        
        data = web.input()
        
        name = data['name']
        weight = float(data['weight'])
        field = data['field']

        dtype = data['dtype']

        convert = {'int':int,
                   'str':str,
                   'float':float}[dtype]

        missing = data['missing'].strip()
        if missing:
            missing = [x.strip() for x in missing.split(',')]
        else:
            missing = []
            
        
        missing = set([convert(x) for x in missing])
        missing.add(None)

        type_ = data['normalizer_type']



        if type_ == 'discrete':
            mapping = {}
            for row in data['mapping'].split('\n'):
                v, s = row.split(',')[:2]
                v = v.strip()
                v = convert(v)
                s = float(s.strip())
                mapping[v] = s
            x = None
            y = None
        else:
            x = []
            y = []
            for row in data['mapping'].split('\n'):
                v, s = row.split(',')[:2]
                v = float(v)
                s = float(s)

                x.append(v)
                y.append(s)
            mapping = None
                
            

        
        p.updateIndicator(vid, component, iid, name, weight, field,
                          missing, type_, dtype, x, y, mapping)
        
        web.seeother('/edit/vulnerability/{}'.format(vid))
        
        
            
        
        
        

        
    
        



if __name__ == "__main__":
    app = web.application(urls, globals())  
    import webbrowser    
    webbrowser.open('http://127.0.0.1:{}/'.format(port),0, True)
    app.run()
        

                
 

        

        

        
