


import project
import cPickle


p = project.Project()

did = p.newDataSource()

p.updateDataSource(did,
                   'Bridges',
                   'bridges.shp',
                   'ID',
                   'name')


vid = p.newVulnerability()

p.updateVulnerability(vid, 'Bridge Indoodashun',
                      {'exposure':2.0,
                       'sensitivity':1.0,
                       'adaptive capacity':1.0})


iid = p.newIndicator(vid, 'exposure')
p.updateIndicator(vid, 'exposure', iid,
                  'rain change', 1.0, 'rain',
                  [-1], 'interpolate', 'float',
                  x = [1, 1.1, 1.2, 1.3],
                  y = [1,2,3,4])

iid = p.newIndicator(vid, 'sensitivity')
p.updateIndicator(vid, 'sensitivity', iid,
                  'oldness', 1.0, 'age',
                  [-1], 'interpolate', 'float',
                  x = [0, 100, 150, 200],
                  y = [1,2,3,4])


iid = p.newIndicator(vid, 'adaptive capacity')
p.updateIndicator(vid, 'adaptive capacity', iid,
                  'On Strategic Network', 1.0, 'strat',
                  ['M'], 'discrete', 'str',
                  mapping = {'y':4, 'n':1})


p.newCalculation(did, vid)

def writeProject(path):

    cPickle.dump(p, open(path, 'wb'))


schema = {'properties':{'ID':'int',
                   'name':'str',
                   'rain':'float',
                   'age':'float',
                   'strat':'str'},
          'geometry':'Point'}


records = []
import random
for i in range(100):
    
    rec = {'properties':{'ID':i,
                   'name':'bridge {}'.format(i),
                   'rain':random.uniform(.9, 1.5),
                   'age':random.randint(0,200),
                   'strat':random.choice('ynMc')},
     'geometry':{'type':'Point',
                 'coordinates':[random.uniform(-80, -70),
                                random.uniform(40,50)]}}

    records.append(rec)

    



import fiona
import fiona.crs

def writeShapeFile(path):

    with fiona.open(path,'w',
                    schema = schema,
                    driver = 'ESRI Shapefile',
                    crs = fiona.crs.from_epsg(4326)) as c:

        c.writerecords(records)

    









